<template>
    <div>
      <el-breadcrumb separator=">">
        <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
        <el-breadcrumb-item>
          <a href="#">基础信息管理</a>
        </el-breadcrumb-item>
        <el-breadcrumb-item>
          部门管理
        </el-breadcrumb-item>
      </el-breadcrumb>
      <el-divider></el-divider>
      <!--
        要resetFields起作用，必须配置:model和prop
      -->
      <el-form ref="queryForm" :model="queryModel" inline class="demo-form-inline">
        <el-form-item label="部门名称" prop="name">
          <el-input type="text" size="mini" v-model="queryModel.name"></el-input>
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            size="mini"
            icon="ios-search"
            @click="changePage(1)"
            :loading="loading"
          >查询</el-button>&nbsp;
          <el-button
            type="info"
            size="mini"
            style="margin-left: 8px"
            @click="handleReset('queryForm')"
          >重置</el-button>&nbsp;
        </el-form-item>
      </el-form>
      <el-divider></el-divider>
      <el-row class="button-group">
        <el-button type="primary" size="small" plain icon="el-icon-circle-plus" @click="handleAdd">新增</el-button>
        <el-button
          type="primary"
          size="small"
          plain
          icon="el-icon-remove"
          :disabled="multipleSelection.length==0"
          @click="handleBatchDelete"
        >删除选中项</el-button>
      </el-row>
      <el-table
        :data="tableData"
        style="min-height:400px;"
        v-loading="loading"
        stripe
        @sort-change="sortChange"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column  prop="name"  label="部门名称"></el-table-column>
        <el-table-column  prop="createTime"  label="创建时间"></el-table-column>
        <el-table-column label="操作" width="250">
          <template slot-scope="{row}" >
            <el-button size="mini" type="warning" @click="handleEdit(row)">编辑</el-button>
            <el-button size="mini" type="danger" @click="handleDelete(row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination
        :current-page.sync="pageIndex"
        :total="totalElements"
        :page-sizes="pageSizeList"
        @current-change="changePage"
        @size-change="pageSizeChange"
        layout="total, sizes, prev, pager, next, jumper"
      ></el-pagination>
      <departmentInfo-detail
        v-if="showModal"
        ref="userDetail"
        :businessKey="businessKey"
        :title="modalTitle"
        @close="onDetailModalClose"
      ></departmentInfo-detail>

    </div>
  </template>
  <script>
  import Constant from "@/constant";
  import departmentInfoApi from "@/api/base/departmentInfo";
  import departmentInfoDetail from "./departmentInfo-detail";
  import { getToken } from "@/utils/auth"; // get token from cookie
  
  export default {
    name: 'baseDepartmentInfoInfo',
    data() {
      var self = this;
  
      return {
        queryModel: {
          name:"",
        },
        loading: false,
        tableData: [],
        pageIndex: 1,
        pageSize: 10,
        totalPages: 0,
        totalElements: 0,
        field: "",
        direction: "",
        pageSizeList: [10, 20, 30],
        multipleSelection: [],
        modalTitle: "",
        modalTitle2: "",        
        businessKey: "",
        showModal: false,
        showModal2:false,
        dialogFormVisible:false,
        newPassword:"",
        roleResult:[],
        props: {
          // 配置项（必选）
          value: "id",
          label: "name",
          children: "children"
        },
        batchImportVisible: false,
        xlsLoading: false,
        batchImportFileList: [],
        chargingStationResult:[],
        uploadUrlXls: Constant.serverUrl + "/base/personInfo/importXls",
        uploadXlsData: {
            subFolder: "personInfo",
        },
        headers: {
            Authorization: getToken(),
        },
        statusList:[
          {
            "id":"0",
            "name":"未认证",
            "value":"0"
          },
          {
            "id":"1",
            "name":"已认证",
            "value":"1"
          }
        ],
      };
    },
    methods: {
      changePage(pageIndex,exportFlag) {
        var self = this;
  
        console.log(pageIndex);
  
        self.pageIndex = pageIndex;
        var formData = new FormData();
  
        formData.append("pageIndex", self.pageIndex);
        
        if(exportFlag!=null){
            formData.append("exportFlag", exportFlag);
            formData.append("pageSize", 10000);
        }
        else{
            formData.append("pageSize", self.pageSize);
        }
        formData.append("name", self.queryModel.name);
  
        self.loading = true;
  
        departmentInfoApi.pageList(formData).then(function(response) {
          self.loading = false;
            var jsonData = response.data;
            if(jsonData.result) {
                if(exportFlag){
                    //导出
                    self.$message({
                        showClose: true,
                        type: "success",
                        message: `报表已生成，<a href="${jsonData.data}">请点击链接下载</a>`,
                        dangerouslyUseHTMLString: true,
                        duration: 30000
                    });
                }
                else{
                    //分页查看
                    var page = jsonData.data;

                    self.tableData = page.data;
                    self.totalPages = page.totalPages;
                    self.totalElements = page.recordsTotal;
                }
            }
            else{
                self.$message.warning(jsonData.message);
            }
        }).catch((error)=>{
          self.loading = false;
        });
      },
      pageSizeChange(pageSize) {
        this.pageSize = pageSize;
      },
      sortChange(data) {
        this.field = data.column.field;
        this.direction = data.order == "ascending" ? "asc" : "desc";
  
        this.changePage(this.pageIndex);
      },
      handleSelectionChange(val) {
        this.multipleSelection = val;
      },
      handleReset(name) {
        this.$refs[name].resetFields();
      },
      handleAdd() {
        var self = this;
        
        self.modalTitle = "新增模板";
        self.businessKey = "";
        self.showModal = true;
      },
      handleEdit(record) {
        var self = this;
        
        self.modalTitle = "编辑模板";
        self.businessKey = record.id;
        self.showModal = true;
      },
      handleOption(record){
        var self = this;
        
        self.modalTitle2 = "编辑项目";
        self.businessKey = record.id;
        self.showModal2 = true;
      },
      handleDelete(record) {
        var self = this;
  
        this.$confirm("是否确认删除？", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
            departmentInfoApi.remove(record.id).then(function(response) {
            var jsonData = response.data;
  
            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);
  
              self.$message({
                type: "success",
                message: "删除成功!"
              });
            }
          });
        });
      },
      handleBatchDelete() {
        var self = this;
  
        var idList = this.multipleSelection.map(record => {
          return record.id;
        });
  
        this.$confirm("是否确认删除选中项？", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
            departmentInfoApi.batchRemove(idList).then(function(response) {
            var jsonData = response.data;
  
            if (jsonData.result) {
              self.changePage(self.pageIndex);
  
              self.$message({
                type: "success",
                message: "删除成功!"
              });
            }
          });
        });
      },
      exportXls() {
        this.changePage(1,true);
      },
        onDetailModalClose(refreshed) {
            this.showModal = false;
    
            if(refreshed) {
            this.changePage(this.pageIndex);
            }
        },
        onDetailModalClose2(refreshed) {
            this.showModal2 = false;
    
            if(refreshed) {
            this.changePage(this.pageIndex);
            }
        },
        beforeUpload(file, fileList) {
            //导入前判断
            var self = this;
            self.xlsLoading = true;
            return true;
        },
        //批量导入-上传成功
        handleBatchImportSuccess(response, file, fileList) {
        var self = this;
        self.xlsLoading = false;

        if (response.result) {
            self.$message.success(response.message);
            this.batchImportFileList = [];
            this.changePage(1);


        } else {
            //this.$message.error(response.message);
            this.batchImportFileList = [];
            this.changePage(1);

            if (response.data != null) {
            //下载有错误信息提示的报表
            //window.open(response.data);
            self.$message({
                showClose: true,
                dangerouslyUseHTMLString: true,
                message:
                response.message +
                `,<a href="${response.data}" target="_blank">点击下载未导入的数据报表</a>&nbsp;`,
                duration: 30000,
            });
            }
        }

        this.batchImportVisible = false;
        },
        //批量导入-预览
        handleBatchImportPreview(file) {
        console.log(file.url);
        },
        //批量导入-移除
        handleBatchImportRemove(file, fileList) {
        console.log(file, fileList);
        },
        //批量导入-移除前操作
        beforeBatchImportRemove(file, fileList) {
        console.log(file, fileList);
        },
        //批量导入-文件超出个数限制时的钩子
        handleBatchImportExceed(files, fileList) {
        this.$message.warning(
            `当前限制选择 3 个文件，本次选择了 ${files.length} 个文件，共选择了 ${
            files.length + fileList.length
            } 个文件`
        );
        },
    },
    mounted: function() {
      var self = this;
      this.changePage(1);
    },
    components: {
        "departmentInfo-detail":departmentInfoDetail,
    }
  };
  </script>
  <style lang="scss" scoped>
  .el-breadcrumb {
    margin: 10px;
    line-height: 20px;
  }
  
  .el-divider {
    margin: 5px 0;
  }
  
  .demo-form-inline {
    margin-left: 10px;
    text-align: left;
  }
  
  .button-group {
    padding: 10px;
    text-align: left;
  }
  </style>